const { spawn, spawnSync, exec } = require('child_process')
const chalk = require('chalk')

const installCreateReactApp = ({ isYarn, projectName }) => {
  console.log(chalk.green(`🥳 Initial project ...`))

  spawnSync(
    isYarn ? 'yarn' : 'npx',
    [
      `${
        isYarn ? 'create react-app' : 'create-react-app'
      } ${projectName} --template typescript`
    ],
    { shell: true, stdio: 'inherit' }
  )
}

module.exports.installCreateReactApp = installCreateReactApp
